//Pinbelegung des Sensors am Arduino
#define Ltrigger 5 //Lila // Arduino Pin an HC-SR04 Trig
#define Lecho 6 //Grau // Arduino Pin an HC-SR04 Echo
#define Links 2

#define Rtrigger 3 //blau
#define Recho 4 //grün
#define Rechts 8

#define ButtonInput A2
#define ButtonOutput 11




/*==============================================================================
________________________________Functions_______________________________________
==============================================================================*/

  // Entfernung in m über gewöhnlichen Ultraschallsensor mit Echo und Trigger messen
  float getEntfernung(float trigger, float echo)
  {
    float entfernung = 0;
    float zeit = 0;

    digitalWrite(trigger, LOW);
    delayMicroseconds(10);
    noInterrupts(); // Fokus auf einen Task -> zur genauen Messung der Microseconds
    digitalWrite(trigger, HIGH); //Trigger Impuls 10 us
    delayMicroseconds(10);
    digitalWrite(trigger, LOW);
    zeit = pulseIn(echo, HIGH); // Echo-Zeit messen
    interrupts(); // gibt wieder Hintergrundprozesse frei
    zeit = (zeit / 2); // Zeit halbieren
    entfernung = (zeit / 29.1) / 100; // Zeit in Meter umrechnen
    return (entfernung);
  }



/*==============================================================================
____________________________________Setup_______________________________________
==============================================================================*/

void setup()
{
  Serial.begin(9600);

  pinMode(Ltrigger, OUTPUT);
  pinMode(Lecho, INPUT);
  pinMode(Links, OUTPUT);

  pinMode(Rtrigger, OUTPUT);
  pinMode(Recho, INPUT);
  pinMode(Rechts, OUTPUT);

  pinMode(ButtonInput, INPUT);
  pinMode(ButtonOutput, OUTPUT);
  digitalWrite(ButtonOutput, LOW);

}

/*==============================================================================
______________________________Main_Loop_________________________________________
==============================================================================*/

void loop()
{
  float entfernungL = getEntfernung(Ltrigger, Lecho);
  float entfernungR = getEntfernung(Rtrigger, Recho);

  digitalWrite(ButtonOutput, LOW);
  float isButtonPressed = analogRead(ButtonInput);
  if(isButtonPressed > 100 ) 
  {
    digitalWrite(ButtonOutput, HIGH);
    delay(100);
  }

    if (entfernungL < 0.8 && entfernungL < entfernungR)
    {
      digitalWrite(Links, HIGH);
      //Serial.println("LinksMessung");
    }

    if (entfernungL >= 0.8)
    {
      digitalWrite(Links, LOW);
     // Serial.println("LLow");
    }

    if (entfernungR < 0.8 && entfernungL > entfernungR) // oder Fehler liegt hier
    {
      digitalWrite(Rechts, HIGH);
     // Serial.println("RechtsMessung");
    }

    if (entfernungR >= 0.8)
    {
      digitalWrite(Rechts, LOW);
     // Serial.println("RLow");
    }

  }
